package com.chinacreator.quartz.directed.file.job;

import com.alibaba.fastjson.JSON;
import com.chinacreator.quartz.directed.file.service.FileOrderService;
import com.chinacreator.quartz.directed.util.DateUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
public class DirectedSyncJob {
    private final static Logger LOGGER = LoggerFactory.getLogger(DirectedSyncJob.class);
    @Autowired
    private FileOrderService fileOrderService;

    @Scheduled(cron="0 0 17 * * ?")
    public void downfile(){
        System.out.println("-----------下载文件-----------");
        Map<String,Object> outmap=new HashMap<>();
        outmap.put("filename","200_sync_order_cancel_"+ DateUtil.getLastDate(-1));
        fileOrderService.downFile(outmap);
        LOGGER.info(DateUtil.NowTimeSS()+"|down_file|"+ JSON.toJSONString(outmap));
    }

    @Scheduled(cron="0 52 09 * * ?")
    public void syncOrder(){
        System.out.println("-----------解析订购记录-----------");
        Map<String,Object> outmap=new HashMap<>();
        List<String> filelist=new ArrayList<>();
        fileOrderService.queryFile(outmap,filelist);
        LOGGER.info(DateUtil.NowTimeSS()+"|order_sync|"+JSON.toJSONString(filelist)+"|"+ JSON.toJSONString(outmap));
    }
}
