package com.chinacreator.quartz.directed.file.service;

import com.chinacreator.quartz.directed.file.bean.DirectedBean;
import com.chinacreator.quartz.directed.file.bean.DirectedJiyueBean;
import com.chinacreator.quartz.directed.file.bean.SFtpConfig;
import com.chinacreator.quartz.directed.file.dao.mydba.DirectedOrderDao;
import com.chinacreator.quartz.directed.util.SFtpUtil;
import com.chinacreator.quartz.directed.util.SerialnumberUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;

import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class FileOrderService {
    @Value("${ftp.url}")
    private String ftpUtl;
    @Value("${ftp.port}")
    private int port;
    @Value(("${ftp.username}"))
    private String username;
    @Value(("${ftp.password}"))
    private String password;
    @Value(("${ftp.temp.fileurl}"))
    private String ftptempurl;
    @Value(("${ftp.fileouturl}"))
    private String ftpouturl;
    @Value(("${ftp.movefiledic}"))
    private String movefiledic;
    @Autowired
    private DirectedOrderDao directedOrderDao;


    public void queryFile(Map<String,Object> outmap, List<String> fileList){
        List<DirectedJiyueBean> productjy=directedOrderDao.queryProductlist();
        fileList=getfileList(ftpouturl);
        for(String filename:fileList){
            Map<String, Integer> inmap = (Map<String, Integer>) outmap.get(filename);
            if (ObjectUtils.isEmpty(inmap)) {
                inmap = new HashMap<>();
                inmap.put("insert", 0);
                inmap.put("update", 0);
                inmap.put("existence", 0);
                inmap.put("error", 0);
            }
            InputStreamReader isr = null;
            FileInputStream fis = null;
            BufferedReader bfStr = null;
            Integer insert=0,update=0,existence=0,error=0;
            try {
                File file = new File(ftpouturl + filename);
                fis = new FileInputStream(file);
                isr = new InputStreamReader(fis, "GBK");
                bfStr = new BufferedReader(isr);
                String strxml = null;
                List<DirectedBean> listorder = new ArrayList<>();
                while ((strxml = bfStr.readLine()) != null) {
                    System.out.println(strxml);
                    String[] strArray = strxml.split("\\|");
                    if (strArray.length > 2) {
                        //serialid|type|usermob|productid|ordertime|canceltime|starttime|endtime|channel|staffid
                        DirectedBean directedBean=new DirectedBean();
                        directedBean.setOrderid(SerialnumberUtil.Getnum(10000000,99999999));
                        directedBean.setCurstatus(strArray[1]);
                        directedBean.setUsermob(strArray[2]);
                        for(DirectedJiyueBean pro:productjy){
                            if(strArray[3].equals(pro.getJyproductid())){
                                directedBean.setProductid(pro.getProductid());
                                directedBean.setProductnewid(pro.getProductnewid());
                                break;
                            }
                        }
                        if(ObjectUtils.isEmpty(directedBean.getProductid())){
                            existence++;
                            continue;
                        }
                        directedBean.setOrdertime(strArray[4]);
                        if("0".equals(directedBean.getCurstatus())){
                            directedBean.setOrderchannel(strArray[8]);
                        }else{
                            directedBean.setCanceltime(strArray[5]);
                            directedBean.setOrderchannel(strArray[8]);
                            directedBean.setCancelchannel(strArray[8]);
                            directedBean.setEndtime(strArray[7]==null?"":strArray[7]);
                        }
                        List<DirectedBean> orderlist=directedOrderDao.queryOrderList(directedBean);
                        if(orderlist.size()>0){
                            if(orderlist.get(0).getCurstatus().equals("0")){
                                if(directedBean.getCurstatus().equals("1")){
                                    directedBean.setOrderid(orderlist.get(0).getOrderid());
                                    try {
                                        directedOrderDao.updateCanecle(directedBean);
                                        update++;
                                    }catch (Exception ef){
                                        ef.printStackTrace();
                                        error++;
                                    }
                                }else{
                                    //都是订购不更新
                                    existence++;
                                }
                            }else{
                                //查询出来是退订不更新不添加
                                existence++;
                            }
                        }else{
                            //保存insert
                            try {
                                directedOrderDao.insertOrder(directedBean);
                                insert++;
                            }catch (Exception ef){
                                ef.printStackTrace();
                                error++;
                            }
                        }
                    }else{
                        existence++;
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }finally {
                inmap.put("insert", insert);
                inmap.put("update", update);
                inmap.put("existence", existence);
                inmap.put("error", error);
                outmap.put(filename, inmap);
                try {
                    if (isr != null) {
                        isr.close();
                    }
                    if (fis != null) {
                        fis.close();
                    }
                    if (bfStr != null) {
                        bfStr.close();
                    }
                } catch (Exception es) {
                    es.printStackTrace();
                }
            }
            movenfile(filename, ftpouturl, movefiledic);
            outmap.put("data",inmap);
        }
    }

    private void movenfile(String filename, String infilepath, String xwmvfilepaht) {
        try {
            File afile = new File(infilepath + filename);
            if (afile.renameTo(new File(xwmvfilepaht + filename))) {
                System.out.println("File is moved successful!");
            } else {
                System.out.println("File is failed to move!");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public List<String> getfileList(String fileupdate) {
        List<String> filestr = new ArrayList<>();
        File file = new File(fileupdate);
        String[] fileList = file.list();
        for (String str : fileList) {
            filestr.add(str);
        }
        return filestr;
    }
    public void downFile(Map<String,Object> outmap){
        SFtpConfig config = new SFtpConfig();
        config.setHost(ftpUtl);
        config.setUserName(username);
        config.setPort(port);
        config.setPassword(password);
        config.setBasePath(ftptempurl);
        config.setSessionConnectTimeout(10000);
        config.setChannelConnectedTimeout(10000);
        config.setProtocol("sftp");
        if (!ObjectUtils.isEmpty(outmap.get("filename"))) {
            InputStream inputStream = null;
            try {
                if (SFtpUtil.downFile(ftptempurl+outmap.get("filename").toString(), ftpouturl+outmap.get("filename").toString(), config)) {
                    outmap.put("fileboolean",true);
                    System.out.println("下载成功：" + outmap.get("filename").toString());
                    return;
                } else {
                    outmap.put("fileboolean",false);
                    System.out.println("下载失败：" + outmap.get("filename").toString());
                }
            } catch (Exception e) {
                e.printStackTrace();
            } finally {
                try {
                    if (inputStream != null) {
                        inputStream.close();
                    }
                } catch (Exception er) {
                    er.printStackTrace();
                }
            }
        }
        outmap.put("fileboolean",false);
    }
}
